SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'KevinKujawski 4/29/2013 19:24'!
blueGhost

	 ^ Ghost new.! !

!PacManTest methodsFor: 'actors' stamp: 'KevinKujawski 4/29/2013 21:06'!
blueberry

	^ Fruit new.! !

!PacManTest methodsFor: 'movements' stamp: 'KevinKujawski 4/29/2013 19:34'!
down

	 ^ (0@(-1))! !

!PacManTest methodsFor: 'construction block types' stamp: 'KevinKujawski 4/29/2013 19:46'!
ghostHouseDoorType

	 ^ GhostHouseDoorType new.! !

!PacManTest methodsFor: 'movements' stamp: 'KevinKujawski 4/29/2013 19:33'!
left

	 ^ (-1@0)! !

!PacManTest methodsFor: 'construction block types' stamp: 'KevinKujawski 4/29/2013 19:56'!
leftTransporterType

	 ^ LeftTransporterType new.! !

!PacManTest methodsFor: 'actors' stamp: 'KevinKujawski 4/29/2013 19:37'!
pacman

	^ Pacman new.! !

!PacManTest methodsFor: 'movements' stamp: 'KevinKujawski 4/29/2013 19:34'!
right

	 ^ (1@0)! !

!PacManTest methodsFor: 'construction block types' stamp: 'KevinKujawski 4/29/2013 19:44'!
spaceType
	 ^ SpaceType new.! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'KevinKujawski 4/29/2013 19:35'!
up

	^ (0@(1))! !

!PacManTest methodsFor: 'construction block types' stamp: 'KevinKujawski 4/29/2013 19:28'!
wallType

	 ^ WallType new.! !

Object subclass: #Actor
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

Actor subclass: #Fruit
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 19:43'!
initialize 

 position := (0@0).! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 21:06'!
nextPositionFor: aType going: aDirection 
	^aType nextPositionForFruit: self going: aDirection.! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 19:38'!
position

 ^position.! !

Actor subclass: #Ghost
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 19:43'!
initialize 

  position := (0@0).! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 20:36'!
nextPositionFor: aType going: aDirection 
	^aType nextPositionForGhost: self going:aDirection.! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 19:26'!
position

 ^position.
! !

Actor subclass: #Pacman
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 19:43'!
initialize 

 position := (0@0).! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 20:35'!
nextPositionFor: aType going: aDirection 
	^aType nextPositionForPacman: self going: aDirection.! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 19:36'!
position

 ^position.! !

Object subclass: #FloorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

FloorType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 20:26'!
nextPositionFor: anActor going: aDirection
	^ anActor nextPositionFor: self going:aDirection.! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 21:06'!
nextPositionForFruit: anActor going:aDirection 
	^anActor position + aDirection.! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 20:41'!
nextPositionForGhost: anActor going:aDirection 
	^anActor position + aDirection.! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 20:40'!
nextPositionForPacman: anActor going:aDirection 
	^anActor position.! !

FloorType subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 20:26'!
nextPositionFor: anActor going: aDirection
	^ anActor nextPositionFor: self going:aDirection.! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 21:06'!
nextPositionForFruit: anActor going:aDirection 
	^(5@10).! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 20:39'!
nextPositionForGhost: anActor going:aDirection 
	^anActor position.! !

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 20:32'!
nextPositionForPacman: anActor going:aDirection 
	^(3@10).! !

FloorType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 19:39'!
nextPositionFor: anActor going: aDirection

^ anActor position + aDirection.! !

FloorType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 4/29/2013 19:31'!
nextPositionFor: anActor going: aDirection

^ anActor position.! !
